"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var inversify_1 = require("inversify");
var common_1 = require("@devpodio/core/lib/common");
var browser_1 = require("@devpodio/core/lib/browser");
var browser_2 = require("@devpodio/languages/lib/browser");
var browser_3 = require("@devpodio/callhierarchy/lib/browser");
var typescript_client_contribution_1 = require("./typescript-client-contribution");
var typescript_callhierarchy_service_1 = require("./typescript-callhierarchy-service");
var typescript_frontend_contribution_1 = require("./typescript-frontend-contribution");
var typescript_keybinding_contexts_1 = require("./typescript-keybinding-contexts");
var typescript_preferences_1 = require("./typescript-preferences");
var typescript_version_service_1 = require("../common/typescript-version-service");
exports.default = new inversify_1.ContainerModule(function (bind) {
    typescript_preferences_1.bindTypescriptPreferences(bind);
    bind(typescript_version_service_1.TypescriptVersionService).toDynamicValue(function (_a) {
        var container = _a.container;
        return browser_1.WebSocketConnectionProvider.createProxy(container, typescript_version_service_1.typescriptVersionPath);
    }).inSingletonScope();
    bind(typescript_client_contribution_1.TypeScriptClientContribution).toSelf().inSingletonScope();
    bind(browser_2.LanguageClientContribution).toService(typescript_client_contribution_1.TypeScriptClientContribution);
    bind(typescript_callhierarchy_service_1.TypeScriptCallHierarchyService).toSelf().inSingletonScope();
    bind(browser_3.CallHierarchyService).toService(typescript_callhierarchy_service_1.TypeScriptCallHierarchyService);
    bind(typescript_frontend_contribution_1.TypeScriptFrontendContribution).toSelf().inSingletonScope();
    bind(common_1.CommandContribution).toService(typescript_frontend_contribution_1.TypeScriptFrontendContribution);
    bind(common_1.MenuContribution).toService(typescript_frontend_contribution_1.TypeScriptFrontendContribution);
    bind(browser_1.KeybindingContribution).toService(typescript_frontend_contribution_1.TypeScriptFrontendContribution);
    bind(browser_1.FrontendApplicationContribution).toService(typescript_frontend_contribution_1.TypeScriptFrontendContribution);
    bind(browser_1.KeybindingContext).to(typescript_keybinding_contexts_1.TypeScriptEditorTextFocusContext).inSingletonScope();
});
