import { interfaces } from 'inversify';
import { PreferenceProxy, PreferenceService, PreferenceSchema, PreferenceChangeEvent } from '@devpodio/core/lib/browser/preferences';
export declare const typescriptPreferenceSchema: PreferenceSchema;
export interface TypescriptConfiguration {
    'typescript.server.log': 'off' | 'terse' | 'normal' | 'verbose';
    'typescript.tsdk'?: string;
}
export declare type TypescriptPreferenceChange = PreferenceChangeEvent<TypescriptConfiguration>;
export declare const TypescriptPreferences: unique symbol;
export declare type TypescriptPreferences = PreferenceProxy<TypescriptConfiguration>;
export declare function createTypescriptPreferences(preferences: PreferenceService): TypescriptPreferences;
export declare function bindTypescriptPreferences(bind: interfaces.Bind): void;
