"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var preferences_1 = require("@devpodio/core/lib/browser/preferences");
exports.typescriptPreferenceSchema = {
    'type': 'object',
    'properties': {
        'typescript.server.log': {
            'type': 'string',
            'enum': [
                'off',
                'terse',
                'normal',
                'verbose'
            ],
            'default': 'off',
            'description': 'Enables logging of the TS server to a file. This log can be used to diagnose TS Server issues. The log may contain file paths, source code, and other potentially sensitive information from your project.'
        },
        'typescript.tsdk': {
            'type': 'string',
            'description': 'Specifies the folder path containing the tsserver and lib*.d.ts files to use.'
        }
    }
};
exports.TypescriptPreferences = Symbol('TypescriptPreferences');
function createTypescriptPreferences(preferences) {
    return preferences_1.createPreferenceProxy(preferences, exports.typescriptPreferenceSchema);
}
exports.createTypescriptPreferences = createTypescriptPreferences;
function bindTypescriptPreferences(bind) {
    bind(exports.TypescriptPreferences).toDynamicValue(function (ctx) {
        var preferences = ctx.container.get(preferences_1.PreferenceService);
        return createTypescriptPreferences(preferences);
    }).inSingletonScope();
    bind(preferences_1.PreferenceContribution).toConstantValue({ schema: exports.typescriptPreferenceSchema });
}
exports.bindTypescriptPreferences = bindTypescriptPreferences;
