export declare const typescriptVersionPath = "/services/ts-version";
export declare type TypescriptVersionQualifier = 'Bundled' | 'Workspace';
export interface TypescriptVersion {
    uri: string;
    version: string;
    qualifier: TypescriptVersionQualifier;
}
export declare namespace TypescriptVersion {
    function equals(one: TypescriptVersion | undefined, another: TypescriptVersion | undefined): boolean;
}
export interface TypescriptVersionOptions {
    workspaceFolders: string[];
    localTsdk?: string;
}
export declare const TypescriptVersionService: unique symbol;
export interface TypescriptVersionService {
    getVersions(options: TypescriptVersionOptions): Promise<TypescriptVersion[]>;
}
