import { ApplicationPackage } from '@devpodio/application-package';
import { BaseLanguageServerContribution, IConnection, LanguageServerStartOptions } from '@devpodio/languages/lib/node';
import { TypescriptStartParams } from '../common';
import { TypeScriptPlugin } from 'typescript-language-server/lib/ts-protocol';
import { Message } from 'vscode-ws-jsonrpc';
export interface TypeScriptStartOptions extends LanguageServerStartOptions {
    parameters?: TypescriptStartParams;
}
export declare class TypeScriptContribution extends BaseLanguageServerContribution {
    readonly id = "typescript";
    readonly name = "TypeScript";
    protected readonly plugins: TypeScriptPlugin[];
    protected readonly applicationPackage: ApplicationPackage;
    protected init(): void;
    start(clientConnection: IConnection, { parameters }: TypeScriptStartOptions): Promise<void>;
    protected map(message: Message): Message;
}
