import URI from '@devpodio/core/lib/common/uri';
import { TypescriptVersion, TypescriptVersionService, TypescriptVersionOptions } from '../common/typescript-version-service';
import { ApplicationPackage } from '@devpodio/application-package';
export declare namespace TypescriptVersionURI {
    function encodeCommand(command: string): URI;
    function getTsServerPath(version: TypescriptVersion | undefined): string | undefined;
}
export declare class TypescriptVersionServiceImpl implements TypescriptVersionService {
    protected readonly applicationPackage: ApplicationPackage;
    getVersions(options: TypescriptVersionOptions): Promise<TypescriptVersion[]>;
    protected resolveBundledVersion(): Promise<TypescriptVersion | undefined>;
    protected resolveBundledVersionInApplicationPath(): Promise<TypescriptVersion | undefined>;
    protected resolveBundledVersionWithRequire(): Promise<TypescriptVersion | undefined>;
    protected resolveBundledVersionAsExecutable(): Promise<TypescriptVersion | undefined>;
    protected resolveWorkspaceVersions(versions: TypescriptVersion[], options: TypescriptVersionOptions): Promise<void>;
    protected resolveVersions(roots: URI[], versions: Map<string, string | undefined>, rawPath: string): Promise<void>;
    protected resolveVersion(versions: Map<string, string | undefined>, uri: URI): Promise<void>;
    protected readVersion(uri: URI): Promise<string | undefined>;
}
